<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\TypeRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\Type;
use App\Language;
use App\Module;
use Users_model;

class TypeController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/types';
    /** View folder */
    private $viewDirectory= 'admin.types.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('types.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the types.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query =Type::orderBy('name', 'ASC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }

        if ($request->lang) {
            $query->whereIn('language_id', currentLanguageid($request->lang) );
        }

      

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $types= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('types'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('types.store');
        $head = metaFields('types', 'add_new', getCurrentLocale()) ?? __('types.new');
        $language = Language::where('status',1)->get();

        return view( $this->viewDirectory.'form', compact('action', 'head','language') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param TypeRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(TypeRequest $request) :RedirectResponse
    {

        foreach ($request->type as $key => $row) {
           $type= Type::create($row);
        }
        

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  type  $type
     * @return View
     */
    public function edit(Type $type): View
    {
        $action= route('types.update', $type->id);
        $head = metaFields('types', 'edit', getCurrentLocale()) ?? __('types.edit');
        $language = Language::where('status',1)->get();

        return view( $this->viewDirectory.'form', compact( 'type','action', 'head' ,'language' ) );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  TypeRequest  $request
     * @param  type  $type
     * @return RedirectResponse|Redirector
     */
    public function update(TypeRequest $request, Type $type) :RedirectResponse
    {
        
        $type->update($request->all());
        

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $type = Type::withTrashed()->find($id);
        if ($type) {
            if ($type->deleted_at) {
                $type->forceDelete();
            } else {
                $type->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Type::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Type::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $type = Type::withTrashed()->find($id);

        if ($type){
            $type->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $type = Type::whereIn('id', $request->ids)->onlyTrashed();
        if ($type){
            $type->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
